#ifndef __H_OCML__
#define __H_OCML__

#define _MANGLE3(P,N,S) P##_##N##_##S
#define MANGLE3(P,N,S) _MANGLE3(P,N,S)
#define OCML_MANGLE_F32(N) MANGLE3(__ocml, N, f32)
#define OCML_MANGLE_F64(N) MANGLE3(__ocml, N, f64)
#define OCML_MANGLE_F16(N) MANGLE3(__ocml, N, f16)

#define DECL_OCML_UNARY_F32(N) extern float OCML_MANGLE_F32(N)(float);
#define _DECL_X_OCML_UNARY_F32(A,N) extern __attribute__((A)) float OCML_MANGLE_F32(N)(float);
#define DECL_PURE_OCML_UNARY_F32(N) _DECL_X_OCML_UNARY_F32(pure, N)
#define DECL_CONST_OCML_UNARY_F32(N) _DECL_X_OCML_UNARY_F32(const, N)

#define DECL_OCML_BINARY_F32(N) extern float OCML_MANGLE_F32(N)(float, float);
#define _DECL_X_OCML_BINARY_F32(A,N) extern __attribute__((A)) float OCML_MANGLE_F32(N)(float, float);
#define DECL_PURE_OCML_BINARY_F32(N) _DECL_X_OCML_BINARY_F32(pure, N)
#define DECL_CONST_OCML_BINARY_F32(N) _DECL_X_OCML_BINARY_F32(const, N)

#define DECL_OCML_UNARY_F64(N) extern double OCML_MANGLE_F64(N)(double);
#define _DECL_X_OCML_UNARY_F64(A,N) extern __attribute__((A)) double OCML_MANGLE_F64(N)(double);
#define DECL_PURE_OCML_UNARY_F64(N) _DECL_X_OCML_UNARY_F64(pure, N)
#define DECL_CONST_OCML_UNARY_F64(N) _DECL_X_OCML_UNARY_F64(const, N)

#define DECL_OCML_BINARY_F64(N) extern double OCML_MANGLE_F64(N)(double, double);
#define _DECL_X_OCML_BINARY_F64(A,N) extern __attribute__((A)) double OCML_MANGLE_F64(N)(double, double);
#define DECL_PURE_OCML_BINARY_F64(N) _DECL_X_OCML_BINARY_F64(pure, N)
#define DECL_CONST_OCML_BINARY_F64(N) _DECL_X_OCML_BINARY_F64(const, N)

DECL_CONST_OCML_UNARY_F32(native_recip)
DECL_CONST_OCML_UNARY_F32(native_sqrt)
DECL_CONST_OCML_UNARY_F32(native_rsqrt)
DECL_CONST_OCML_UNARY_F32(native_sin)
DECL_CONST_OCML_UNARY_F32(native_cos)
DECL_CONST_OCML_UNARY_F32(native_exp)
DECL_CONST_OCML_UNARY_F32(native_exp2)
DECL_CONST_OCML_UNARY_F32(native_exp10)
DECL_CONST_OCML_UNARY_F32(native_log)
DECL_CONST_OCML_UNARY_F32(native_log2)
DECL_CONST_OCML_UNARY_F32(native_log10)

DECL_CONST_OCML_BINARY_F32(fmax)
DECL_CONST_OCML_BINARY_F64(fmax)

DECL_CONST_OCML_BINARY_F32(fmin)
DECL_CONST_OCML_BINARY_F64(fmin)

DECL_CONST_OCML_UNARY_F32(fabs)
DECL_CONST_OCML_UNARY_F64(fabs)

DECL_CONST_OCML_UNARY_F32(ceil)
DECL_CONST_OCML_UNARY_F64(ceil)

DECL_CONST_OCML_UNARY_F32(floor)
DECL_CONST_OCML_UNARY_F64(floor)

DECL_CONST_OCML_UNARY_F32(cos)
DECL_CONST_OCML_UNARY_F64(cos)

DECL_CONST_OCML_UNARY_F32(sin)
DECL_CONST_OCML_UNARY_F64(sin)

DECL_CONST_OCML_UNARY_F32(exp2)
DECL_CONST_OCML_UNARY_F64(exp2)
#endif
